#pragma once

#include "BaseQueryProcessor.h"
#include "../base/EntityQueryProcessorBase.h"

#include "../../../core/longtermmemory/Entity.h"

#include "EntityQueryProcessor.h"

namespace armarx::armem::ltm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class EntityQueryProcessor :
        virtual public BaseQueryProcessor<ltm::Entity, armem::query::data::EntityQuery>,
        virtual public base::query_proc::EntityQueryProcessorBase<ltm::Entity>
    {
        using Base = BaseQueryProcessor<ltm::Entity, armem::query::data::EntityQuery>;

    public:
        EntityQueryProcessor() :
            Base()
        {}

    private:
        void addResultSnapshot(ltm::Entity& result, ltm::Entity::ContainerT::const_iterator it) const override
        {
            addResultSnapshot(result, it->second);
        }

        void addResultSnapshot(ltm::Entity& result, const ltm::EntitySnapshot& snapshot) const override
        {
            ARMARX_INFO << "addResultSnapshot" << __LINE__;
            result.addSnapshot(snapshot.copy());
        }

    };

}
